- Qt 6.7
- Qt 3D
- C++ Classes
- Qt3DRender
- QSetFence
- Qt 6.7.3 Reference Documentation

# QSetFence Class

class Qt3DRender::QSetFence

FrameGraphNode used to insert a fence in the graphics command stream. More...

Header: | #include <QSetFence>
CMake: | find_package(Qt6 REQUIRED COMPONENTS 3drender) target_link_libraries(mytarget PRIVATE Qt6::3drender)
qmake: | QT += 3drender
Inherits: | Qt3DRender::QFrameGraphNode

- List of all members, including inherited members

## Properties

- handle : const QVariant
- handleType : const HandleType

## Public Functions

QVariant | handle() const
Qt3DRender::QSetFence::HandleType | handleType() const

## Signals

void | handleChanged(QVariant handle)
void | handleTypeChanged(Qt3DRender::QSetFence::HandleType handleType)

## Detailed Description

Fence allow to synchronosize GPU and CPU workloads. GPU commands usually are non-blocking. When issued, commands are inserted in command buffers which will be read at a later time by the GPU. In some cases, you want to continue processing or issue specific command only when you are sure a command has been executed by the hardware. Fences are a way to do so. This is especially important when using 3rd party engines with Qt3D, Qt3D should only access shared resources when we know the other engine command are done modifying the resource.

QSetFence is a FrameGraph node that inserts a fence into the command stream. It can then be used in conjunction with QWaitFence or by extracting the underlying handle.

The handle property will be updated once the renderer has created the underlying fence resource. The handle will remain valid as long as it remains in the unsignaled state. Once it has reached the signaled state, it will be destroyed and a new handle will be created. That means that depending on how long it takes for the fence to be signaled, the same handle could be used over several frames.

## Property Documentation

### `[read-only]` handle : const QVariant

Holds the underlying fence handle wrapped in a QVariant.

Access functions:

QVariant | handle() const

Notifier signal:

void | handleChanged(QVariant handle)

### `[read-only]` handleType : const HandleType

Specifies the type of handle being used. Currently only OpenGL Fence ids are supported.

Access functions:

Qt3DRender::QSetFence::HandleType | handleType() const

Notifier signal:

void | handleTypeChanged(Qt3DRender::QSetFence::HandleType handleType)